/*
 * @Author: husanfeng
 * @qq:1136014061
 * @Date: 2018-09-03
 * @Last Modified by: husanfeng
 * @Last Modified time: 2018-09-03
 */
export default class Server {

  constructor(params) {

  }
  fetchData(url, param) {
    let URI = `${process.env.API.emsAdminURL + url}`;
    return new Promise((resolve) => {
      $axios.post(URI, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  /**
   * 大类配置 分页查询
   * @param {Object} param 
   */
  queryCategoryCfgPage(param = null) {
    if (param) {
      return this.fetchData('/category/cfg/queryCategoryCfgPage', param);
    }
  }
  /**
   * 大类配置 新增业务大类配置
   * @param {Object} param 
   */
  addBigCategoryCfg(param = null) {
    if (param) {
      return this.fetchData('/category/cfg/addBigCategoryCfg', param);
    }
  }
  /**
   * 大类配置 修改业务大类配置
   * @param {Object} param 
   */
  updateBigCategoryCfg(param = null) {
    if (param) {
      return this.fetchData('/category/cfg/updateBigCategoryCfg', param);
    }
  }
  /**
   * 大类配置 删除业务大类配置
   * @param {Object} param 
   */
  deleteBigCategoryCfg(param = null) {
    if (param) {
      return this.fetchData(`/category/cfg/deleteBigCategoryCfg/${param}`);
    }
  }
  /**
    * 查询项目信息
    */
  queryCompanys(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsBaseDataURL}/project/findPagedProjectList`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
}