/*
 * @Author: husanfeng
 * @qq:1136014061
 * @Date: 2018-09-03
 * @Last Modified by: husanfeng
 * @Last Modified time: 2018-09-03
 */
export default class Server {
  constructor(params) {
  }
  fetchData(url, param) {
    let URI = `${process.env.API.emsAdminURL + url}`;
    return new Promise((resolve) => {
      $axios.post(URI, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  /**
   * 查询导入适配器配置数据
   * @param {Object} param 
   */
  getCategoryAdaptCfgList(param = null) {
    if (param) {
      return this.fetchData('/category/getCategoryAdaptCfgList', param);
    }
  }
  /**
   * 新增 或者更新 导入适配器配置数据
   */
  addOrUpdateCategoryAdaptCfg(param = null) {
    if (param) {
      return this.fetchData('/category/addOrUpdateCategoryAdaptCfg', param);
    }
  }
  /**
   * 删除导入适配器配置数据
   * @param {Object} param 
   */
  deleteCategoryAdaptCfg(param = null) {
    if (param) {
      return this.fetchData(`/category/deleteCategoryAdaptCfg/${param}`);
    }
  }
  /**
   * 查询适配器配置数据,只查询已启用数据，返回数据为集合对象数据类型
   * @param {Object} param 
   *  /isValidity	String	传值为 Y 的参数		
   */
  getCategroyAdaptList(param = null) {
    if (param) {
      return this.fetchData('/claimAdapt/getCategoryAdaptList', param);
    }
  }
}