function tree(data, rootMenu, option = {}) {

    this.json = [];
    this.newJson = [];
    this.dataSource = data;
    this.children = option.children;
    this.selected = option.selected;
    this.getRootMenu();
    if (option.root) {
        this.json = [{
            "expand": true,
            "title": "/",
            children: this.json
        }]
    }
    for (let m of this.json) {
        this.pushNode(m.menuId, m);
    }!!option.sort && this.sort(this.json);

    for (let m of this.json) {
        if (m.menuCode == rootMenu.menuCode) {
            this.newJson.push(Object.assign({}, m, {}));
        }
    }
}

tree.prototype.getRootMenu = function() {

    for (let m of this.dataSource) {
        m.selected = this.selected && this.selected.indexOf(m.menuId) >= 0 ? true : false;
        m.checked = this.children && this.children.indexOf(m.menuId) >= 0 ? true : false;
        m.expand = true;
        if (!m.menuModuleId) {
            this.json.push(Object.assign({}, m, {
                title: m.menuName,
                children: []
            }))
        }
    }
}

tree.prototype.pushNode = function(id, node) {
    if (node.menuModuleId == '') {

        node.fullPathName = node.menuName;
    }
    for (let m of this.dataSource) {
        if (m.menuModuleId == id) {
            node.children = !node.children ? [] : node.children;
            node.children.push(Object.assign({}, m, {
                title: m.menuName,
                fullPathName: node.fullPathName + "/" + m.menuName,
                children: []
            }))
            this.pushNode(node.children[node.children.length - 1].menuId, node.children[node.children.length - 1]);
        }
    }
}

tree.prototype.sort = function(list) {
    list = list.sort(function(a, b) {
        return a.sort - b.sort;
    })
    for (let node of list) {
        if (!!node.children && node.children.length > 0) {
            this.sort(node.children);
        }
    }
}

export default tree