import { systemRouter } from 'ripples-core'
import { emsAdminRouter } from './routerExport'
import { pscRouter } from 'ripples-psc'
import { Home, Main } from "ems-components"

//###--- 替换ripples-core的路由组件，实现个性化
systemRouter.appRouter.component = Main
systemRouter.otherRouter.component = Main

systemRouter.otherRouter.children.some(item => {
  if (item.name === "home_index") {
    item.component = Home
    return true;
  }
})
//-------###

systemRouter.appRouter.children = systemRouter.appRouter.children.concat(emsAdminRouter, pscRouter)

const appRouter = systemRouter.appRouter;

const routersTemp = systemRouter.routers.concat(appRouter)

const beforeEach = systemRouter.afterEach

const afterEach = systemRouter.afterEach;


// #### 去除重复的路由

function removeDuplicate(sourceArr){
  const tempObj = {}
  const tempArr = []

  sourceArr.map(item => {
    tempObj[item.name] = item
  })

  for (let key in tempObj) {
    tempArr.push(tempObj[key])
  }

  return tempArr
}

let routers = removeDuplicate(routersTemp)

routers.map(item => {
  if(item.name == "system"){
    item.children = removeDuplicate(item.children)
  }
})
// 去除重复的路由 ####

export {
  appRouter,
  routers,
  beforeEach,
  afterEach,
  emsAdminRouter,
}