import axios from 'axios';
import extend from 'extend';
import qs from 'qs';

let util = {

};

util.isArray = function isArray(arr) {
	if (typeof Array.isArray === 'function') {
		return Array.isArray(arr);
	}

	return toStr.call(arr) === '[object Array]';
};
util.inOf = function (arr, targetArr) {
    let res = true;
    arr.map(item => {
        if (targetArr.indexOf(item) < 0) {
            res = false;
        }
    });
    return res;
};

util.oneOf = function (ele, targetArr) {
    if (targetArr.indexOf(ele) >= 0) {
        return true;
    } else {
        return false;
    }
};

util.showThisRoute = function (itAccess, currentAccess) {
    if (typeof itAccess === 'object' && itAccess.isArray()) {
        return util.oneOf(currentAccess, itAccess);
    } else {
        return itAccess === currentAccess;
    }
};

// util.getPathObjByName = function (vm, name) {
//     let pathObj = vm.$store.state.routers.filter((item) => {
//         if (item.children.length <= 1) {
//             return item.name === name;
//         } else {
//             let i = 0;
//             let childArr = item.children;
//             let len = childArr.length;
//             while (i < len) {
//                 if (childArr[i].name === name) {
//                     return true;
//                 }
//                 i++;
//             }
//             return false;
//         }
//     })[0];
//     return pathObj;
// };

util.setCurrentPath = function (vm, name) {
    let pathList = []
    let i = $store.state.userMenu.findIndex((item) => {
        return item.actionUrl == name;
    })
    switch (name) {
        case 'feedback':
            pathList.unshift({
                title: '我的建议反馈',
                path: 'feedback',
                name: name
            })
            break;
    }
    if (!!~i) {
        pathList.unshift({
            title: $store.state.userMenu[i].menuName,
            path: $store.state.userMenu[i].actionUrl,
            name: name
        })
        util.getPathObjByName(pathList, $store.state.userMenu[i].menuModuleId);
    }
    pathList.unshift({
        title: '首页',
        path: '/home',
        name: 'home_index'
    })
    $store.commit('setCurrentPath', pathList);
    return pathList
};
util.getPathObjByName = function (list, menuId) {
    let i = $store.state.userMenu.findIndex((item) => {
        return item.menuId == menuId;
    })
    if (i > -1) {
        list.unshift({
            title: $store.state.userMenu[i].menuName,
            path: $store.state.userMenu[i].actionUrl,
            name: name
        })
        util.getPathObjByName(list, $store.state.userMenu[i].menuModuleId);
    }
}

util.openPage = function (vm, name, title) {
    vm.$router.push({
        name: name
    });
    let hasOpened = false;
    vm.pageTagsList.forEach((item, index) => {
        if (item.name === name) {
            hasOpened = true;
            vm.$store.commit('moveToSecond', index);
        }
    });
    if (!hasOpened) {
        vm.$store.commit('increateTag', { name: name, title: title });
    }
};
util.copyPros = function (source, target, excludeNames = [], callback = function () { }) {

    // 强制都是深拷贝
    let tempTarget = extend(true, {}, target);
    if (Object.prototype.toString.call(source) != '[object Object]') {
        console.error('source must be a object!');
        return;
    }
    if (Object.prototype.toString.call(target) != '[object Object]') {
        console.error('target must be a object!');
        return;
    }
    if (excludeNames && Object.prototype.toString.call(excludeNames) != '[object Array]') {
        console.error('excludeNames must be a array!');
        return;
    }
    for (let key of Object.keys(source)) {
        if (!excludeNames || !excludeNames.includes(key)) {
            source[key] = tempTarget[key];
        }
    }
    return source;
};

util.arrCopy = function (arr) {
    let newArr = [];
    arr.forEach((item, i) => {
      let obj = extend(true, {}, item)
      newArr.push(obj);
    })
    return newArr;
}

//用这个
util.getUrlParams = function () {
    // !!!这里不能取location.search,因为如果值里面有#那么会有截断现象，只能取href
    let searchStr = location.href.split('?')[1];
    let result = {};
    if (!searchStr) {
        return result;
    } else {
        return qs.parse(searchStr);
    }
};

util.getDaysDiff = function (startDay, endDay) {
    return Math.floor((endDay - startDay) / 1000 / 60 / 60 / 24 + 0.5);
}

util.closeWebPage = function () {
    if (navigator.userAgent.indexOf("MSIE") > 0) {
        if (navigator.userAgent.indexOf("MSIE 6.0") > 0) {
            window.opener = null;
            window.close();
        } else {
            window.open('', '_top');
            window.top.close();
        }
    }
    else if (navigator.userAgent.indexOf("Firefox") > 0) {
        window.location.href = 'about:blank ';
    } else {
        window.opener = null;
        window.open('', '_self', '');
        window.close();
    }
}
util.getUrlVarsFromRequest=function() { 
    var vars = {}, hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for (var i = 0; i < hashes.length; i++) {
        hash = hashes[i].split('=');
        vars[hash[0]] = decodeURIComponent(hash[1]);
    }
    return vars;
}
//文件下载通用方法
util.downloadFile = function(param = {}, vue){
    return new Promise((resolve) => {
    vue.$Spin.show({
      render: (h) => {
        return h('div', [
          h('Icon', {
            'class': 'demo-spin-icon-load',
            props: {
              type: 'load-c',
              size: 18
            }
          }),
          h('div', '正在努力下载附件，请稍候...')
        ])
      }
    });
    $axios({
        method: param.method || 'get',//方法
        url: `${param.url}`,//地址
        responseType: 'blob',
        headers: {
        crctoken: sessionStorage.crctoken
        },
        data: param.data || {}
        }).then(response => {
        if (!response.data) {
            return
        }
        let url = window.URL.createObjectURL(new Blob([response.data]));
        let _fileName = response.headers['content-disposition'].split("=");
        let fileName = param.name || (!!_fileName && _fileName.length > 1 ? _fileName[1] : 'file');
        //兼容IE10+、edge
        if (window.URL.createObjectURL(new Blob()).indexOf(location.host) < 0) {
            if (window.navigator.msSaveOrOpenBlob) {//IE10+方法
            const blobObject = new Blob([response.data], {type: 'text/html'});
            window.navigator.msSaveOrOpenBlob(blobObject, decodeURI(fileName));
            }
        //兼容chrome、fireFox
        }else{
            let link = document.createElement('a')
            link.style.display = 'none'
            link.href = url
            link.setAttribute('download', decodeURI(fileName))
            document.body.appendChild(link)
            link.click()
        };
        vue.$Spin.hide();
        resolve({
            msg : "导出成功"
        })
        })
    })
}


util.openByClaimIdAndClaimNo = function (claimId, claimNo) {
    window.$store
      .dispatch("QueryProcessInfoByClaimNo", {
        claimNo: claimNo,
      })
      .then(response => {
        // if(!response.list[0]){
        //   console.log(window)
        //   return $app.$Message.warning("暂无可跳转链接")
        // }
        let dataResult = response.list[0];
        let origin = "";
        if (location.origin != location.href.split('/#')[0]) {
          origin = location.href.split('/#')[0];
        } else {
          origin = location.origin;
        }
        let params = {
          singlePage: "YES",
          claimId: claimId,
          showPayment: true,//控制是否可编辑
          // editPaymentInfo: true,
          paymentFlag: true,
          source: "manager",
          actionType: "done",
          actId: dataResult ? dataResult.actId : 'FROM_HAIDIANYINKE',
        };
        if (response.list.length != 0) {
          let processParams = (response.list[0].taskLocalVariables[0].url).split("?");
          let processArr = processParams[1].split("&");
          for (let i = 0; i < processArr.length; i++) {
            if (processArr[i].split("=")[0] == "procInstId") {
              params.procInstId = processArr[i].split("=")[1]
            }
            if (processArr[i].split("=")[0] == "taskId") {
              params.taskId = processArr[i].split("=")[1]
            }
          }
        }
        let url = "";
        url = `${origin}/#/blank?pageName=create-payment-apply&${qs.stringify(
          params
        )}&crctoken=${sessionStorage.crctoken}`
        window.open(url);
      })
    // .catch(error => {});  
  }

  util.openTaskFromBillOfAccount = function (data) {
    let singlePage = 'NO';
    let pageName = '';
    let origin = util.getOrigin();
    let url = "";
    let startUserCode = "";
    let currentNodeName = data.currentTaskName;
    let taskDefinitionKey = data.actID;
    let currentTaskId = "";
    // 获取跳转URL
    url = data.taskLocalVariables[0].url;
    if (url) {
      // let pathname = location.pathname;
      // url = (pathname.length <= 1 ? origin + '/' : (origin + pathname)) + url;
      url = origin + "/" + url
    } else {
      $app.$Message.error('该条数据无跳转的URL参数');
      return;
    }
  
    startUserCode = data.processVariables[0].procStartUserLdapId;
  
    // 获取当前节点taskId
    currentTaskId = data.currentTaskID;
  
    if (process.env.API.env === "dev") {
      if (url.indexOf("8080") >= 0) {
        url = origin + url.split("8080")[1];
      } else if (url.indexOf("8081") >= 0) {
        url = origin + url.split("8081")[1];
      } else if (url.indexOf("8082") >= 0) {
        url = origin + url.split("8082")[1];
      } else if (url.indexOf("8083") >= 0) {
        url = origin + url.split("8083")[1];
      }
    }
  
    url = url.replace(/([^\?\/]+)(?=\?)/, "#/$1");
    pageName = url.split('?')[0].split('/#/')[1]

    // for (let item of routers) {
    //   if (item.name == /([^\?\/])+(?=\?)/.exec(url)[0]) {
    //     url = url.replace(/([^\?\/]+)(?=\?)/, "#/$1");
    //     singlePage = 'YES';
    //     pageName = item.name;
    //     break;
    //   }
    // }
    //ap
    if (pageName == 'payment-plan') {
      pageName = 'create-payment-apply';
    }
    //gl
    if (pageName == 'payment-plan-gl') {
      pageName = 'create-payment-apply';
    }
    let targetUrl = `${url}&singlePage=${singlePage}&pageName=${pageName}&currentTaskId=${currentTaskId}&taskDefinitionKey=${taskDefinitionKey}&currentNodeName=${currentNodeName}&userCode=${
      $store.state.userInfo.userCode || $store.state.reimburseComment.vm.loginInfo.userCode || this.getUrlParams().userCode || ''
      }&startUserCode=${startUserCode}&categoryCode=${data.catalogyCode || data.categoryCode}&actionType=${data.actionType}&fromPendingRead=${data.fromPendingRead}&fromPendingFeedBack=${data.fromPendingFeedBack}&crctoken=${
      sessionStorage.crctoken
      }`;
  
    if (data.fromPendingFeedBack == 'Y' || data.fromAlreadyFeedBack == 'Y') {
      targetUrl = targetUrl
        + `&feedBackCreateUserCode=${data.feedBackCreateUserCode}&feedBackCreateUserName=${data.feedBackCreateUserName}&feedBackId=${data.id}`
    }
  
    if (data.fromPendingRead == 'Y' || data.fromAlreadyRead == 'Y') {
      targetUrl = targetUrl
        + `&readId=${data.id}`
    }
  
    if (data.source) {
      targetUrl = targetUrl
        + `&source=${data.source}`
    }
    if (targetUrl.split('?').length == 2) {
      let targetUrlHead = targetUrl.split('?')[0];
      let targetUrlTail = targetUrl.split('?')[1];

      let targetUrlTailParams = qs.parse(targetUrlTail);
      for (let key of Object.keys(targetUrlTailParams)) {
        if (this.isArray(targetUrlTailParams[key])) {
          targetUrlTailParams[key] = targetUrlTailParams[key][0];
        }
      }
      // console.log(targetUrlHead + '?' + qs.stringify(targetUrlTailParams))
      window.open(targetUrlHead + '?' + qs.stringify(targetUrlTailParams));
    } else {
      $app.$Message.error('该条数据URL参数格式有误');
    }
  }
// 获取URL上的origin
util.getOrigin = function () {
    let origin = "";
    if (location.origin != location.href.split('/#')[0]) {
      origin = location.href.split('/#')[0];
    } else {
      origin = location.origin;
    }
    return origin
  }
export default util;
