export default class Server {
  constructor(params) {
  }
  /**
     * 模糊查询组织
     */
  queryOrgListData(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/orgElasticity/queryOrgByName/${param}`, {}).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }

  /**
      * 根据组织id查询组织详情
      */
  queryOrgDetailById(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/orgElasticity/queryOrgDetailById/${param}`, {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }

  /**
     * 新增组织
     */
  addSubOrg(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/orgElasticity/addSubOrg`, param).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }
  /**
     * 删除组织deleteOrgData
     */
  deleteOrgData(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/orgElasticity/deleteSelectOrg/${param}`, {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }
  /**
     * 编辑组织
     */
  updateSelectOrg(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/orgElasticity/updateSelectOrg`, param).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }
  /**
    * 根据组织ID查询组织
    */
  queryOrgListDataByOrgId(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/org/findOrg/${param}`, {}).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }


  /**
  * 查询初始化的三层组织信息
  */
  queryInitializationOrgs(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/org/findOrgs` + (param ? ("/" + param.name) : ""), {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }

  /**
    * 根据组织code查询下一级组织部门
    */
  querySubOrgsByOrgCode(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/org/findSubOrgs/` + param.orgId, {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }
  /**
    * 根据组织名称查询组织数据
    */
  queryOrgByOrgName(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/org/findOrg` + (param ? ("/" + param.name) : ""), {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }


}