export default class Server {
  constructor(params) {
  }
  /**
     * 分页查询业务类别列表 
     */
  QueryBusinessBigClassList(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/queryBigCategoryPage`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 保存业务大类
  SaveBusinessBigClassDatas(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/saveOrUpdateCategory`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  /**
    * 删除业务类别列表
    */
  DeleteBusinessBigClass(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/deleteCategory/${param}`, "").then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  /**
     * 查询适配器列表
     */
  // queryAdapterList(param = {}) {
  //   return new Promise((resolve) => {
  //     $axios.post(`${process.env.API.emsAdminURL}/claimAdapt/getCategoryAdaptList`, param).then((response) => {
  //       resolve(response);
  //     }).catch((error) => {
  //       let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
  //       resolve(responseData);
  //     })
  //   })
  // }

  /**
   *
    * 查询全部业务小类列表
    */
  queryBusinessSmallClassList(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/subcategory/findSubcategoryList`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  /**
   *
    * 查询已选择的业务小类列表
    */
  querySelectBusinessSmallClassList(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/querySubCatByCode/${param}`, "").then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 获取最新大类编码
  getNewCategory(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/getNewCategoryCode`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }


  // 查询适用组织列表  /category/org/queryCategoryOrgPage
  QueryOrgTableDatas(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/org/queryCategoryOrgPage`, param).then((response) => {

        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 保存新增适用组织列表
  SaveOrgFormDatas(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/org/addBigCategoryOrg`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 更新适用组织列表
  UpdateOrgFormDatas(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/org/updateBigCategoryOrg`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 删除适用组织列表
  DeleteOrgFormDatas(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/org/deleteBigCategoryOrg/${param}`, {}).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }

  // 删除适用流程列表
  DeleteProcessTableDatas(param = {}) {
    return new Promise((resolve) => {
      let url = `${process.env.API.claimURL}/claimBroad/delete`;
      let index = url.indexOf("ems-admin")
      if (index != -1) {
        url = url.replace("ems-admin", "");
      }
      $axios.post(url, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 保存适用流程列表
  SaveProcessTableDatas(param = {}) {
    return new Promise((resolve) => {
      let url = `${process.env.API.claimURL}/claimBroad/save`;
      let index = url.indexOf("ems-admin")
      if (index != -1) {
        url = url.replace("ems-admin", "");
      }
      // http://10.0.49.58/ems-admin/ems-claim/claimBroad/listPageNoForm
      $axios.post(url, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 保存新增BU映射
  SaveBUMappingDatas(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/bu/addCategoryBuRef`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 删除BU映射
  DeleteBUMappingDatas(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/bu/deleteBigCategoryOrg/${param}`, {}).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  DeleteBUMapping(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/bu/deleteCategoryBuRef`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 修改BU映射
  EditBUMappingDatas(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/bu/updateCategoryBuRef`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  // 查询BU映射
  QueryBUMappingDatas(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/category/bu/queryCategoryBuRefPage`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
}