/**
 *  业务小类服务层
 * @author changanmin1@crc.com.hk
 */
export default class Server {

    constructor(params) {

    }
    fetchData(type, url, param = {}) {
        let URI = `${process.env.API.emsAdminURL + url}`;
        if (type === 'get') {
            return new Promise((resolve) => {
                $axios.get(URI, param).then((response) => {
                    resolve(response);
                }).catch((error) => {
                    let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
                    resolve(responseData);
                })
            })
        } else {
            return new Promise((resolve) => {
                $axios.post(URI, param).then((response) => {
                    // let cmenus = [{ "categoryCode": "0001", "categoryName": "adfdfdf", "menuName": "aaaaa" }];
                    // response.data.list = cmenus;
                    resolve(response);
                }).catch((error) => {
                    let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
                    resolve(responseData);
                })
            })
        }
    }

    /** 
     * 分页查找业务大类菜单
     * @param{
          @categoryCode //业务大类编码  非必须
          @categoryName //业务大类名称 非必须
          @menuName //菜单名称 非必须
     * }
     */
    findCategoryMenuPage(param = {}) {

            return this.fetchData('post', '/menucategory/selectMenuCategoryPage', param);
        }
        /**
         * 删除业务大类菜单
         * param Object 
         *    id 主键
         */
    delCategoryMenu(param = null) {
        return param && this.fetchData('post', `/menucategory/deleteByPrimaryKey?id=${param}`);
    }

    addCategoryMenu(params) {
        if (params) {
            return this.fetchData('post', '/menucategory/insertMenuCategoryMapping', params);
        }
    }

}