/**
 *  业务小类服务层
 * @author changanmin1@crc.com.hk
 */
export default class Server {

  constructor(params) {

  }
  fetchData(type, url, param = {}) {
    let URI = `${process.env.API.emsAdminURL + url}`;
    if (type === 'get') {
      return new Promise((resolve) => {
        $axios.get(URI, param).then((response) => {
          resolve(response);
        }).catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
      })
    } else {
      return new Promise((resolve) => {
        $axios.post(URI, param).then((response) => {
          resolve(response);
        }).catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
      })
    }
  }
  /**
   * 检查输入的小类CODE 是否已存在
   * @param {*} param 小类code
   */
  checkSubcategoryCode(param = null) {
    return param && this.fetchData('post', '/subcategory/checkSubcategoryCode/' + param.subcategoryCode);
  }
  /** 
   * 分页查找业务小类
   * @param{
        @categoryCode //业务类别  非必须
        @subcategoryCode //业务小类编码 非必须
        @subcategoryName //业务小类名称 非必须
        @valid //有效性 非必须
        @lang //多语言编码 非必须
   * }
   */
  findSubcategoryPage(param = {}) {
    return this.fetchData('post', '/subcategory/findSubcategoryPage', param);
  }
  /**
   * 业务小类首页
   * 删除业务小类业务
   * param Object 
   *    subcategoryCode 业务小类编码
   */
  delSubcategory(param = null) {
    return param && this.fetchData('post', `/subcategory/delSubcategory/${param}`);
  }
  /**
   * 业务小类 
   * 查询详情
   * @param Object
   *    @subcategoryCode 业务小类编码
   */
  queryDetail(param = null) {
    if (param) {
      return new Promise((resolve) => {
        $axios.post(`${process.env.API.emsAdminURL}/subcategory/findSubcategoryById/${param}`).then((response) => {
          resolve(response);
        }).catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
      })
    }
  }
  addSubcategory(params){
    if(params){ 
      return this.fetchData('post', '/subcategory/addSubcategory', params);
    }
  }
  updateSubcategory(params){
    if(params){ 
      return this.fetchData('post', '/subcategory/updateSubcategory', params);
    }
  }



/** 小类配置 */
/**
 * 小类配置分页 查找
 */
querySubcategoryCfgPage(param){ 
  if(param){ 
    return this.fetchData('post', '/subcategory/cfg/findSubcategoryCfgPage', param);
  }
}
/**
 * 检测小类配置编码是否可用
 * @param {String} param 
 */
checkSubcategoryCfgCode(param){
  if(param){ 
    return this.fetchData('post', `/subcategory/cfg/checkSubcategoryCfgCode/${param}`);
  }
}
//新增小类配置
saveSubcategoryCfg(param){
  if(param){ 
    return this.fetchData('post', `/subcategory/cfg/addSubcategoryCfg`,param);
  }
}
//更新小类配置
updateSubcategoryCfg(param){
  if(param){ 
    return this.fetchData('post', `/subcategory/cfg/updateSubcategoryCfg`,param);
  }
}
delSubcategoryCfg(param){
  if(param){
    return this.fetchData('post', `/subcategory/cfg/delSubcategoryCfg/${param}`);
  }
}

  //查询付款准备列表
  queryPayPrepare(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsPaymentUrl}/payPrepareQuery/queryPayPrepareInfo`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }

}