/**
 *  城市服务层
 * @author changanmin1@crc.com.hk
 */
export default class Server {

  constructor(params) {

  }
  fetchData( url, param = {}) {
    let URI = `${process.env.API.emsAdminURL + url}`;
    return new Promise((resolve) => {
      $axios.post(URI, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    });
  }
  /**
   * 根据ID查询城市详情
   * @param {String} param 城市ID
   */
  findCityById(param = null){
    return param && this.fetchData(`/city/findById/${param}`);
  }
  /**
   * 城市分页查询
   * @param {Object} param
   */
  findByPage(param = null) {
    return param && this.fetchData('/city/findByPage',param);
  }
  // 更新
  updateCity(param = null){
    return param && this.fetchData('/city/updateCity',param)
  }
  //添加
  addCity(param = null){
    return param && this.fetchData('/city/addCity',param)
  }
  //删除
  delCity(param = null){
    return param && this.fetchData(`/city/delCity/${param}`);
  }
}