export default class Server {
  constructor(param) {

  };
  fetchData(url, param = {}) {
    let URI = `${process.env.API.budgetManageURL + url}`;
    return new Promise((resolve) => {
      $axios.post(URI, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务器异常， 请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  };
  //分页查询主数据列表
  queryCountList(param) {
    // return param && this.fetchData('/budgetAmountController/list/page', param)
    return param && this.fetchData('/budgetDetailAmount/list/page', param)
  };
  //分页查询模板列表
  queryTemplateList(param) {
    return param && this.fetchData('/budgetTemplateController/list/page', param)
  };
  //根据模板ID查询动态列数据
  getDynamicColumnsList(param) {
    return param && this.fetchData(`/budgetTemplateController/list/segment/${param}`, param)
  };
  //导出数据
  exportData(param) {
    return param && this.fetchData(`/budgetDetailAmount/export/data`, param)
  };

  // 根据值集代码查询
  queryValueSetByCode(param) {
    return new Promise((resolve) => {
      $axios.get(`${process.env.API.baseURL}/sys/valueset/item/list/${param.code}`).then((response) => {
        if(response.statusCode != '-1') {
          let result = [];
          for (let item of response.data.dataResult) {
            result.push({ label: item.vsiValue, value: item.vsiKey });
          }
          resolve(result);
        }else {
          let responseData = { "dataResult": [], "extra": "", "msg": (response.msg || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        }
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
}