// 仅在开发环境下使用mock数据
// if(process.env.API.mock) {
//   require('./mock')
// }

export default class Server {

  constructor(params) {

  }

  _errReporter(error) {
    return { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
  }

  _axios(url, param) {
    return new Promise((resolve) => {
      $axios.post(url, param).then((response) => {
       
        resolve(response);
      }).catch((error) => {
        resolve(this._errReporter(error));
      })
    })
  }


  /**
    * 调取接口获取值列表
    */
   findValueList(param = {}) {
    return this._axios(`${process.env.API.budgetManageURL}/budgetStructureController/valueCode/page`, param)
  }







  /**
    * 查询初始化的三层组织信息
    */
   queryInitializationOrgs(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/org/findOrgs` + (param ? ("/" + param.name) : ""), {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": "服务异常，请联系管理员", "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }

  /**
    * 根据组织code查询下一级组织部门
    */
  querySubOrgsByOrgCode(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/org/findSubOrgs/` + param.orgId, {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": "服务异常，请联系管理员", "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }

  /**
    * 根据组织code查询员工
    */
  queryEmployeeByOrgCode(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/org/findSubEmployees/` + param.orgId, {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": "服务异常，请联系管理员", "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }

  /**
    * 根据组织名称查询组织数据
    */
  queryOrgByOrgName(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/org/findOrg/${param.name}`, {}).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": "服务异常，请联系管理员", "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }

  /**
    * 根据员工姓名查询员工
    */
  queryEmployeeByName(param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.claimURL}/org/findEmployee/${param.name}`, param).then((response) => {
        resolve(response.data);
      })
        .catch((error) => {
          let responseData = { "dataResult": [], "extra": "", "msg": "服务异常，请联系管理员", "statusCode": "-1" };
          resolve(responseData);
        })
    })
  }
}