// 仅在开发环境下使用mock数据
// if(process.env.API.mock) {
//   require('./mock')
// }

export default class Server {

  constructor(params) {

  }

  _errReporter(error) {
    return { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
  }

  _axios(url, param) {
    return new Promise((resolve) => {
      $axios.post(url, param).then((response) => {
        console.log(url, response)
        resolve(response);
      }).catch((error) => {
        resolve(this._errReporter(error));
      })
    })
  }


  /**
    * 税率值列表
    */
  findTaxRateValueList(param = {}) {
    return this._axios(`${process.env.API.emsAdminURL}/tax/findTaxRateValueList`, param)
  }

  /**
    * 根据税率值查询税率类型列表
    */
  findTaxStypeCodeList(param = {}) {
    const rateVal = encodeURIComponent(param.rateVal)
    return this._axios(`${process.env.API.emsAdminURL}/tax/findTaxStypeCodeList/${rateVal}`)
  }
}