/**
 *  流程管理 --> 审核人配置
 * @author changanmin1@crc.com.hk
 */
export default class Server {
   
  constructor(params) { 
    this.seachParam = {};
  }
  
  fetchData( url, param = {}) {
    let URI = `${process.env.API.emsAdminURL + url}`;
    return new Promise((resolve) => {
      $axios.post(URI, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    });
  }
  //添加
  add(param = null){
    return param && this.fetchData(`/delegateCompany/addDelegateCompany`,param);
  }
  //分页查询
  find(param = null) {
    this.seachParam = param;
    return param && this.fetchData('/delegateCompany/queryDelegateCompanyPage',param);
  }
  // 更新
  update(param = null){
    return param && this.fetchData('/delegateCompany/updateDelegateCompany',param)
  } 
  //删除{orgCompId}
  del(param = null){
    return param && this.fetchData(`/delegateCompany/deleteDelegateCompany/${param}`);
  }
  //导出
  export(param){ 
    let url = `${process.env.API.emsAdminURL}/delegateCompany/exportDelegateCompany`
    return new Promise(resolve => { 
      $axios({
        method:'post',
        url:url, 
        data:param,
        responseType:'blob'
      }).then(response => { 
        resolve(response);
      })
      .catch(error => {
        let responseData = {
          dataResult: [],
          extra: "",
          msg: error.response.data.message || "服务异常，请联系管理员",
          statusCode: "-1"
        };
        resolve(responseData);
      });
    });
  }
}