// // 仅在开发环境下使用mock数据
// if(process.env.API.mock) {
//   require('./mock')
// }

export default class Server {

  constructor(params) {

  }

  _errReporter(error) {
    return { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
  }

  _axios(path, param) {
    return new Promise((resolve) => {
      const url = `${process.env.API.emsPaymentUrl}/${path}`
      $axios.post(url, param).then((response) => {
        console.log(url, response)
        resolve(response);
      }).catch((error) => {
        resolve(this._errReporter(error));
      })
    })
  }

  QueryValueSetByCode(param) {
    return new Promise((resolve) => {
      $axios.get(`${process.env.API.baseURL}/sys/valueset/item/list/${param.code}`).then((response) => {
        if (response.data.statusCode == '0') {
          let result = [];
          for (let item of response.data.dataResult) {
            result.push({ label: item.vsiValue, value: item.vsiKey });
          }
          resolve(result);
        } else {
          let responseData = { "dataResult": [], "extra": "", "msg": (response.data.msg || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        }
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }

  /**
    * 拉取付款工作台配置 列表数据 / 查询
    */
  getPaymentTableDatas(param = {}) {
    return this._axios('payment/config/select', param)
  }

  /**
    * 删除 可批量
    */
  delSettingBatch(param = {}) {
    return this._axios('payment/config/deleteBatch', param)
  }

  /**
    * 新增 配置
    */
  addSetting(param = {}) {
    return this._axios('payment/config/insert', param)
  }

  /**
    * 批量修改
    */
  editSettingBatch(param = {}) {
    return this._axios('payment/config/updateBatch', param)
  }

  /**
    * 单个修改
    */
  editSetting(param = {}) {
    return this._axios('payment/config/update', param)
  }

  /**
    * 批量删除用户权限
    */
  delUserPermissionBatch(param = {}) {
    return this._axios(`payment/config/deleteBatch/user/permission?manualEmpId=${param.manualEmpId}`, param.companyCodeList)
  }

  /**
    * 付款准备工作台配置按照companyCode查询单条记录
    */
  getSettingByCompanyCode(param = {}) {
    return this._axios(`payment/config/load/${param.companyCode}`, param)
  }

}