/**
 *  主数据 --> 供应商管理
 * @author changanmin1@crc.com.hk
 */
export default class Server {

  constructor(params) {

  }
  fetchData( url, param = {}) {
    let URI = `${process.env.API.emsBaseDataURL + url}`;
    return new Promise((resolve) => {
      $axios.post(URI, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    });
  }
   
  //分页查询
  find(param = null) {
    return param && this.fetchData('/vendor/findPagedVendorList',param);
  }
  //详情
  detail(param = null){
    return param && this.fetchData(`/vendor/queryVendorInfoById/${param}`);
  } 
  //供应商银行信息 
  getbankInfo(param = {}){ 
    return param && this.fetchData(`/vendorAccount/queryMdVendorAccountPage`,param);
  }
  // 供应商地址信息  
  getAddressInfo(param = {}){
    return param && this.fetchData(`/vendorSite/queryMdVendorSitePage`,param);
  }

}