export default class Server {
  constructor(params) {
  }
  fetchData( url, param = {}) {
    let URI = `${process.env.API.emsAdminURL + url}`;
    return new Promise((resolve) => {
      $axios.post(URI, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    });
  }
  /**
   * 分页查询
   */
  QueryTaxRateList(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/tax/findTaxRateList`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  }
  /**
   * 税率值列表,只包含启用状态
   */
  queryTaxRateValueList(param = {}) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.emsAdminURL}/tax/findTaxRateValueList`, param).then((response) => {
        resolve(response);
      }).catch((error) => {
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  } 
  //添加税率
  add(param = {}){
    return this.fetchData('/tax/addTaxRate',param);
  }
  //修改税率
  update(param = {}){
    return this.fetchData('/tax/updateTaxRate',param);
  }
  //删除税率
  del(param = null){ 
    return param && this.fetchData(`/tax/delTaxRate/${param}`);
  }
}