export default {
  QueryProcessList: function ({ commit }, param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.pscURL}/psc/procdef/pscActReProcdef/list/page`, param).then((response) => {
        resolve(response.data.dataResult);
      })
        .catch((error) => {
         
          let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
          resolve(responseData);
        })
    })
  },
  // 查询适用流程列表
  QueryProcessTableDatas: function ({ commit }, param) {
    return new Promise((resolve) => {
      let url = `${process.env.API.claimURL}/claimBroad/listPageNoForm`;
      let index = url.indexOf("ems-admin")
      if (index != -1) {
        url = url.replace("ems-admin", "");
      }
      $axios.post(url, param).then((response) => {
        resolve(response.data.dataResult);
      }).catch((error) => {
       
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  },
  QueryRoles: function ({ commit }, param) {
    return new Promise((resolve) => {
      $axios.post(`${process.env.API.baseURL}/sys/role/list/page`, param).then((response) => {
        resolve(response.data.dataResult);
      }).catch((error) => { 
        let responseData = { "dataResult": [], "extra": "", "msg": (error.response.data.message || "服务异常，请联系管理员"), "statusCode": "-1" };
        resolve(responseData);
      })
    })
  },
}