import Vue from 'vue'
import Vuex from 'vuex'
import state from './state'
import actions from './actions'
import mutations from './mutations'
import getters from './getters'
import adminBusinessBigClassManage from './modules/adminBusinessBigClassManage/index.js'
import orgDimension from './modules/orgDimension/index.js'
import orgType from './modules/orgType/index.js'
import defineBudgetOrg from './modules/defineBudgetOrg/index.js'
import { vuexModules, rootModules } from 'ripples-core';
// import { vuexPscModules } from 'ripples-psc'
import vuexEmsComponents from 'ems-components'

Vue.use(Vuex)

export default new Vuex.Store({
    state: Object.assign({}, state, rootModules.state, vuexEmsComponents.state),
    actions: Object.assign({}, actions, rootModules.actions, vuexEmsComponents.actions),
    mutations: Object.assign({}, mutations, rootModules.mutations, vuexEmsComponents.mutations),
    getters: Object.assign({}, getters, rootModules.getters, vuexEmsComponents.getters),
    modules: Object.assign({}, vuexModules, {

        adminBusinessBigClassManage,
        orgDimension,
        orgType,
        defineBudgetOrg,
    })
})